﻿package {

	import Box2DAS.Dynamics.ContactEvent;

	import com.citrusengine.core.State;
	import com.citrusengine.objects.PhysicsObject;
	import com.citrusengine.objects.platformer.Hero;
	import com.citrusengine.objects.platformer.Platform;
	import com.citrusengine.physics.Box2D;
	
	/**
	 * @author Aymeric
	 */
	public class MyState extends State {

		public function MyState() {
			super();
		}
		
		override public function initialize():void {
			
			var box2d:Box2D = new Box2D("Box2d");
			//box2d.visible = true;
			add(box2d);
			
			var hero:Hero = new Hero("Hero", {x:50, width:30, height:60, view:"hero.swf"});
			add(hero);
			
			var treadmill:Treadmill = new Treadmill("Treadmill", {x:200, y:300, width:400, height:20, view:"treadmill.swf"});
			add(treadmill);
			
			treadmill.enabled = false; //remove moving platform
			
			var teleporter:Teleporter = new Teleporter("Teleporter", {x:300, y:250, width:20, height:20, view:"teleporter.swf"});
			add(teleporter);
			
			teleporter.endX = 50;
			teleporter.endY = 0;
			teleporter.time = 200;
			
			teleporter.onBeginContact.add(_teleport);
			
			Platform.Make("Platform", -5, 150, 5, 300);
			
			var cannon:Cannon = new Cannon("Cannon", {x:450, y:170, width:40, height:40, view:"cannon.swf"});
			add(cannon);
			
			cannon.fireRate = 2500;
			cannon.startingDirection = "left";
			cannon.missileFuseDuration = 4000;
			cannon.missileView = "missile.swf";
			cannon.startFire();
			
			cannon.onGiveDamage.add(_cannonHurt);
		}

		private function _teleport(cEvt:ContactEvent):void {
			
			if (cEvt.other.GetBody().GetUserData() is Hero) {
				cEvt.fixture.GetBody().GetUserData().object = cEvt.other.GetBody().GetUserData();
				cEvt.fixture.GetBody().GetUserData().needToTeleport = true;
			}
		}
		
		private function _cannonHurt(contact:PhysicsObject):void {
			
			if (contact is Hero) {
				Hero(contact).hurt();
			}
		}
	}
}
